/*
 * helper_functions.hpp
 *
 *  Created on: Aug 23, 2017
 *      Author: julien
 */

#ifndef SRC_MODULES_HELPER_FUNCTIONS_HELPER_FUNCTIONS_HPP_
#define SRC_MODULES_HELPER_FUNCTIONS_HELPER_FUNCTIONS_HPP_


#include "../../OpenCV_includes.hpp"
#include "../Function/Function.hpp"


void draw_pointcollection(Mat* src, vector<vector<Point>>* pointcollection);
void draw_points(Mat* src, vector<Point>* points, Scalar color);
void draw_points(Mat* src, vector<Point>* points_l, Scalar color_l,
				 vector<Point>* points_r, Scalar color_r);


void draw_lane_points(Mat* src, vector<vector<vector<Point>>>* contours);


void print_mat_info(Mat a);
void print_vector_vector(vector<vector<Point>> vec);


void to_pPointsVector(vector<vector<Point>>* src, vector<vector<Function::pPoint>>* out);
void to_pPoints(vector<Point>* src, vector<Function::pPoint>* out);
void to_pPoints(vector<Point>* src_l, vector<Function::pPoint>* out_l,
				vector<Point>* src_r, vector<Function::pPoint>* out_r);


void to_PointsVector(vector<vector<Function::pPoint>>* src, vector<vector<Point>>* out);
void to_Points(vector<Function::pPoint>* src, vector<Point>* out);
void to_Points(vector<Function::pPoint>* src_l, vector<Point>* out_l,
			   vector<Function::pPoint>* src_r, vector<Point>* out_r);


template <typename T>
void print_vector(vector<T> vector, String identifier){
	for(unsigned int i = 0; i < vector.size(); i++){
			cout << identifier << " " << i << " : " << vector.at(i) << endl;
		}
}

void print_mat(Mat M, String identifier);


#endif /* SRC_MODULES_HELPER_FUNCTIONS_HELPER_FUNCTIONS_HPP_ */
